SystemOrganization addCategory: #MemoryMentor!
SystemOrganization addCategory: #'MemoryMentor-Tests'!
SystemOrganization addCategory: #'MemoryMentor-Visualization'!
SystemOrganization addCategory: #'MemoryMentor-Core'!

Morph subclass: #MMCellGroupMorph
	instanceVariableNames: 'cells type displayMode container valueMorphs contextMenu memoryMorph pointerArrows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 11:12:07.924'!
byteHeight
	^ TextStyle default defaultFont height + 5! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 11:11:09.818'!
byteWidth
	^ (TextStyle default defaultFont widthOf: $0) * (8+4)! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 10:43:54.146'!
defaultDisplayMode
	^ #hexadecimal
	! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 11:15:05.714'!
defaultWidth
	^ self byteWidth * 4! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:57:35.886'!
for: cellOrCells in: aMemoryMorph
	 ^ self new
		memoryMorph: aMemoryMorph;
		cells: cellOrCells;
		setup! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 13:52:23.43'!
addPointerArrow: aPointerArrow
	pointerArrows add: aPointerArrow! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:51:55.534'!
address
	^ cells first address! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:56:07.708'!
byteValueAt: address
	^ type caseOf: {
		[ #char ] -> [ self memory charAt: address ].
		[ #uchar ] -> [ self memory ucharAt: address ].
	} otherwise: [ self memory byteAt: address ]! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 11:46:38.254'!
cells
	 ^ cells! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 15:14:47.492'!
cells: cellOrCells
	cells := cellOrCells isCollection
				ifTrue: [ cellOrCells ]
				ifFalse: [ Array with: cellOrCells ].
	self updateContent! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 13:52:47.272'!
clearPointerArrows
	pointerArrows do: #remove! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 14:19:23.64'!
contentValue
	^ type caseOf: {
		[ #pointer ] -> [ self memory ulongAt: self address ].
		[ #long ] -> [ self memory longAt: self address ].	
		[ #ulong ] -> [ self memory ulongAt: self address ].
		[ #int ] -> [ self memory intAt: self address ].
		[ #uint ] -> [ self memory uintAt: self address ].
		[ #float ] -> [ self memory floatAt: self address ].
	} otherwise: [ 0 ]! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 14:15:08.702'!
createAddressMorph
	| width labelMorph |
	width := (TextStyle default defaultFont widthOf: $0) * 
			(('0x', (cells first memory endAddress printStringBase: 16)) size + 1).
	labelMorph := MMMemoryAddressMorph forAddress: cells first address width: width height: self class byteHeight .
	"self updateTooltipWith: labelMorph addressString."
	^ labelMorph! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:56:32.708'!
createByteMorph: i of: cell
	^ self createValueMorph
		extent: (self class byteWidth @ self class byteHeight);
		value: (self byteValueAt: cell address + i);
		yourself! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:56:50.62'!
createByteMorphs
	| byteMorphs |
	byteMorphs := OrderedCollection new.
	cells do: [ :cell | 0 to: 3 do: [ :i | (byteMorphs add: (self createByteMorph: i of: cell)) ] ].
	^ byteMorphs! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:52:14.682'!
createCellMorph
	^ self createValueMorph
		extent: (self class byteWidth * 4) @ (self class byteHeight * cells size);
		value: self contentValue;
		yourself! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:47:59.612'!
createContent
	^ (#(raw char uchar bool) includes: type)
			ifTrue: [ self createByteMorphs ]
			ifFalse: [ Array with: self createCellMorph ]! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 14:22:02.326'!
createContextMenu
	| formatMenu typeMenu |
	formatMenu := MenuMorph new
		add: 'Binary' target: self selector: #displayMode: argument: #binary;
		add: 'Decimal' target: self selector: #displayMode: argument: #decimal;
		add: 'Hexadecimal' target: self selector: #displayMode: argument: #hexadecimal;
		add: 'ASCII' target: self selector: #displayMode: argument: #ascii;
		yourself.
	typeMenu := MenuMorph new
		add: 'Raw' target: self selector: #type: argument: #raw;
		add: 'Pointer' target: self selector: #type: argument: #pointer;
		add: 'Integer' target: self selector: #type: argument: #int;
		add: 'Unsigned Integer' target: self selector: #type: argument: #uint;
		add: 'Long' target: self selector: #type: argument: #long;
		add: 'Unsigned Long' target: self selector: #type: argument: #ulong;
		add: 'Float' target: self selector: #type: argument: #float;
		yourself.
	
	^ MenuMorph new
		add: 'Display as ...' subMenu: formatMenu;
		add: 'Interpret as ...' subMenu: typeMenu;
		add: 'Retarget Pointer' target: self selector: #retargetPointer;
		yourself! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 14:31:24.99'!
createValueMorph
	^ MMValueMorph new
		color: (Color gray: 0.9);
		displayMode: displayMode;
		layoutPolicy: TableLayout new;
		listDirection: #lefttoRight;
		listCentering: #center;
		yourself! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 15:18:28.708'!
displayMode
	^ displayMode! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 14:16:33.652'!
displayMode: aSymbol
	displayMode := aSymbol.
	self displayModeChanged! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 14:16:28.098'!
displayModeChanged 
	valueMorphs do: [ :valueMorph | valueMorph displayMode: displayMode ]! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 13:52:03.844'!
initialize 
	super initialize.
	contextMenu := self createContextMenu.
	valueMorphs := OrderedCollection new.
	pointerArrows := OrderedCollection new.
	type := #raw.
	container := Morph new
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		listCentering: #left;
		yourself.
	self
		displayMode: self class defaultDisplayMode;
		color: Color white;
		wantsYellowButtonMenu: true;
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		listCentering: #left.! !

!MMCellGroupMorph methodsFor: 'accessing' stamp: 'RL 5/22/2013 13:51:17.422'!
memory
	^ memoryMorph memory ! !

!MMCellGroupMorph methodsFor: 'accessing' stamp: 'RL 5/15/2013 14:36:58.93'!
memoryMorph
	^ memoryMorph! !

!MMCellGroupMorph methodsFor: 'accessing' stamp: 'RL 5/15/2013 14:36:58.94'!
memoryMorph: anObject
	memoryMorph := anObject! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:45:06.658'!
merge: size
	memoryMorph merge: self size: size! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 14:09:14.056'!
removePointerArrow: aPointerArrow
	pointerArrows remove: aPointerArrow! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 13:49:27.204'!
retargetPointer
	MMPointerArrow from: self! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 14:34:06.35'!
setup
	self
		addMorphBack: self createAddressMorph;
		addMorphBack: container;
		updateContent;
		extent: self fullBounds extent! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:44:44.176'!
split
	memoryMorph split: self! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 14:17:16.374'!
type: aSymbol
	type := aSymbol.
	self typeChanged ! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:49:36.164'!
typeChanged
	(#(pointer long ulong double) includes: type)
		ifTrue: [ self merge: 2 ]
		ifFalse: [ self split ].
		
	self updateContent ! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 14:33:46.89'!
updateContent
	container submorphsDo: #delete.
	valueMorphs := self createContent.
	container addMorphs: valueMorphs! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 14:05:26.422'!
yellowButtonActivity: shiftKeyState
	contextMenu popUpInWorld! !

Morph subclass: #MMMemoryAddressMorph
	instanceVariableNames: 'address stringMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMMemoryAddressMorph class methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:57:57.018'!
forAddress: anInteger width: width height: height
	^ self new
		address: anInteger;
		initializeWithWidth: width height: height;
		yourself! !

!MMMemoryAddressMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:58:21.63'!
address
	^ address! !

!MMMemoryAddressMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 11:02:55.924'!
address: anInteger
	address := anInteger.
	
	self updateStringMorph! !

!MMMemoryAddressMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 11:02:33.592'!
addressString
	 ^ '0x', (address printStringBase: 16)! !

!MMMemoryAddressMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 11:03:18.186'!
initializeWithWidth: width height: height
	super initialize.
	
	stringMorph := StringMorph new.
	
	self color: Color white;
		extent: width@height;
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		listCentering: #center;
		addMorph: stringMorph.
	
	self updateStringMorph! !

!MMMemoryAddressMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 11:03:39.056'!
updateStringMorph
	stringMorph ifNil: [ ^ self ].
	
	stringMorph contents: self addressString! !

Morph subclass: #MMMemoryMorph
	instanceVariableNames: 'memory groupMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMMemoryMorph commentStamp: 'RL 5/15/2013 14:38:05.526' prior: 0!
(MMMemoryMorph for: (MMMemory withStartAddress: 16r100 bytes:  #[104 101 108 108 111] cellCount: 20)) openInHand!

!MMMemoryMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:14:59.09'!
for: memory
	^ self new
		setupMemory: memory;
		yourself! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 14:39:17.882'!
initialize
	super initialize.
	
	groupMorphs := OrderedCollection new.
		
	self
		color: Color red;
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		"listDirection: #topToBottom;
		wrapDirection: #leftToRight;"
		listDirection: #leftToRight;
		wrapDirection: #topToBottom;
		listCentering: #center
! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:52:34.346'!
memory
	^ memory! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:02:34.86'!
memory: aMemory
	memory := aMemory! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 15:53:07.046'!
merge: aGroup size: anInteger
	| index toSplit count i toMerge cells |
	index := groupMorphs indexOf: aGroup.
	
	toSplit := OrderedCollection new.
	count := 0.
	i := 0.
	[ count < anInteger ] whileTrue: [ | group |
		group := groupMorphs at: index + i ifAbsent: [ self error: 'caution!! you are about to leave the memory.' ].
		toSplit add: group.
		count := count + group cells size.
		i := i + 1.
	].
	toSplit do: [ :each | self split: each].
	
	toMerge := groupMorphs copyFrom: index to: index + anInteger - 1.
	cells := toMerge flatCollect: [ :group | group cells ].
	groupMorphs removeAll: toMerge.
	toMerge allButFirst do: #delete.
	toMerge first cells: cells.
	groupMorphs add: toMerge first beforeIndex: index.! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 14:40:06.682'!
setupMemory: aMemory
	memory := aMemory.
	memory cellsDo: [ :cell | | groupMorph |
		groupMorph := MMCellGroupMorph for: cell in: self.
		groupMorphs add: groupMorph.
	].
	self
		addMorphs: groupMorphs;
		extent: self fullBounds extent.! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 15:18:15.422'!
split: aGroup
	| index newGroups |
	index := groupMorphs indexOf: aGroup.
	newGroups := aGroup cells allButFirst collect: [ :cell | MMCellGroupMorph for: cell in: self ].
	aGroup cells: aGroup cells first.
	newGroups reverseDo: [ :group |
		group displayMode: aGroup displayMode.
		groupMorphs add: group afterIndex: index.
		self addMorph: group after: aGroup
	].
	! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 14:38:36.112'!
wantsYellowButtonMenu
	"Answer true if the receiver wants a yellow button menu"
	^ false! !

Morph subclass: #MMRightAngledArrow
	instanceVariableNames: 'from to spacing arrowBorderWidth points horizontalLungeDirection verticalLungeDirection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMRightAngledArrow class methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 14:01:59.012'!
from: aPoint to: anotherPoint
	^ self from: aPoint to: anotherPoint spacing: 30! !

!MMRightAngledArrow class methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 14:01:37.892'!
from: aPoint to: anotherPoint spacing: anInteger
	^ super new
		spacing: anInteger;
		initializeFrom: aPoint to: anotherPoint;
		yourself! !

!MMRightAngledArrow class methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 13:58:08.482'!
new
	^ self shouldNotImplement! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 13:41:07.756'!
arrowBoundsAt: endPoint from: priorPoint 
	"Answer a triangle oriented along the line from priorPoint to endPoint."
	| d v angle wingBase arrowSpec length width |
	v := endPoint - priorPoint.
	angle := v degrees.
	d := arrowBorderWidth max: 1.
	arrowSpec := self valueOfProperty: #arrowSpec ifAbsent: [5@4].
	length := arrowSpec x abs.  width := arrowSpec y abs.
	wingBase := endPoint + (Point r: d * length degrees: angle + 180.0).
	arrowSpec x >= 0
		ifTrue: [^ {	endPoint.
					wingBase + (Point r: d * width degrees: angle + 125.0).
					wingBase + (Point r: d * width degrees: angle - 125.0) }]
		ifFalse: ["Negative length means concave base."
				^ {	endPoint.
					wingBase + (Point r: d * width degrees: angle + 125.0).
					wingBase.
					wingBase + (Point r: d * width degrees: angle - 125.0) }]! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 11:47:34.906'!
bottomLunge
	^ 0 @ -1! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 13:46:08.27'!
drawArrowOn: canvas
	self assert: [ points size >= 2].
	
	points overlappingPairsDo:[ :p1 :p2 |
		canvas line: p1 to: p2 width: arrowBorderWidth color: Color black
	].
	canvas
		drawPolygon: (self arrowBoundsAt: points last from: (points at: points size - 1))
		color: Color white borderWidth: arrowBorderWidth borderColor: Color black! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 13:35:45.466'!
drawOn: aCanvas
	aCanvas
		translateBy: self owner position
		during: [ :canvas | self drawArrowOn: canvas ].! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 13:43:09.388'!
initialize
	super initialize.
	
	arrowBorderWidth := 2.
	spacing := 30.
	points := OrderedCollection new.
	horizontalLungeDirection := #right.
	verticalLungeDirection := #top! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 14:00:42.904'!
initializeFrom: aPoint to: anotherPoint
	| bounds |
	self assert: [ aPoint ~= anotherPoint ].
	
	from := aPoint.
	to := anotherPoint.
	self initializePoints.
	bounds := from rect: to.
	points do: [ :point | bounds := bounds encompass: point ].
	(self arrowBoundsAt: points last from: (points at: points size - 1)) do: [ :point | bounds := bounds encompass: point ].
	self bounds: (bounds outsetBy: arrowBorderWidth)! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 14:09:49.454'!
initializePoints
	from ifNil: [ ^ self ].
	to ifNil: [ ^ self ].
	
	points := OrderedCollection new.
	
	points add: from.
	
	true caseOf: {
		[ (from x - to x) abs >= spacing and: [ (from y - to y) abs >= spacing ] ] -> [
			(from x - to x) abs < (from y - to y) abs ifTrue: [
				points add: from x @ (from interpolateTo: to at: 0.5) y.
				points add: to x @ (from interpolateTo: to at: 0.5) y.
			] ifFalse: [
				points add: (from interpolateTo: to at: 0.5) x @ from y.
				points add: (from interpolateTo: to at: 0.5) x @ to y.
			]
		].
		[ (from x - to x) abs >= spacing and: [ (from y - to y) abs < spacing ] ] -> [ | tempY |
			tempY := verticalLungeDirection == #top ifTrue: [ (from y max: to y) + spacing ] ifFalse: [ (from y min: to y) - spacing ].
			points add: from x @ tempY.
			points add: to x @ tempY
		].
		[ (from x - to x) abs < spacing and: [ (from y - to y) abs >= spacing ] ] -> [ | tempX |
			tempX := horizontalLungeDirection == #left ifTrue: [ (from x min: to x) - spacing ] ifFalse: [ (from x max: to x) + spacing ].
			points add: tempX @ from y.
			points add: tempX @ to y
		].
		[ (from x - to x) abs < spacing and: [ (from y - to y) abs < spacing ] ] -> [
			"straight line, so add no points"
		]
	}.
	
	points add: to! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 13:58:35.68'!
points
	^ points! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 14:00:25.938'!
spacing: anInteger
	spacing := anInteger.
	
	self initializePoints! !

Morph subclass: #MMToolTippedMorph
	instanceVariableNames: 'tooltip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 13:06:17.438'!
createTooltip
	tooltip := BorderedMorph new.
	tooltip
		color: Color yellow muchLighter paler;
		borderWidth: 1.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 13:03:13.85'!
handlesMouseMove: event
	^ true! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 10:50:32.461'!
hideTooltip
	tooltip delete.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 13:08:21.123'!
initialize
	super initialize.
	self 
		createTooltip;
		initializeEvents.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 10:51:29.41'!
initializeEvents
	self on: #mouseEnter send: #mouseEnter to: self.
	self on: #mouseMove send: #moveTooltip to: self.
	self on: #mouseLeave send: #mouseLeave to: self.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 10:51:19.744'!
mouseEnter
	self addAlarm: #showTooltip after: 1000.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 10:51:09.543'!
mouseLeave
	self removeAlarm: #showTooltip.
	self hideTooltip.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 10:50:51.349'!
moveTooltip
	tooltip position: ActiveHand center.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 10:50:25.524'!
showTooltip
	tooltip position: ActiveHand center.
	World addMorph: tooltip.
	tooltip fadeIn.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 13:08:24.159'!
updateTooltipWith: aMessage
	tooltip
		removeAllMorphs;
		addMorph: (StringMorph new contents: aMessage; yourself);
		bounds: tooltip fullBounds.! !

BorderedMorph subclass: #MMValueMorph
	instanceVariableNames: 'value displayMode stringMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMValueMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:30:30.952'!
displayModes
	^ #(ascii binary decimal hexadecimal)! !

!MMValueMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:34:39.726'!
displayMode
	 ^ displayMode! !

!MMValueMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:35:34.384'!
displayMode: aSymbol
	(self class displayModes includes: aSymbol)
		ifFalse: [ self error: 'invalid display mode' ].
	displayMode := aSymbol.
	self updateValueString ! !

!MMValueMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:39:05.124'!
initialize 
	super initialize.
	displayMode := #decimal.
	value := 0.
	stringMorph := StringMorph new.
	self addMorph: stringMorph.
	self updateValueString ! !

!MMValueMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:39:17.134'!
updateValueString
	stringMorph contents: self valueString! !

!MMValueMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:32:53.034'!
value
	^ value! !

!MMValueMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:33:37.134'!
value: anInteger
	value := anInteger.
	self updateValueString ! !

!MMValueMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:37:28.718'!
valueString
	^ displayMode caseOf: {
		[ #decimal ] -> [ value printString ].
		[ #binary ] -> [ ((value printStringBase: 2) padded: #left to: 8 with: $0), 'b' ].
		[ #hexadecimal ] -> [ '0x', (value printStringBase: 16) padded: #left to: 2 with: $0 ].
		[ #ascii ] ->[ value >= 32
				ifTrue:[ (Character value: value) asString printString ]
				ifFalse: [ ('\', value asString) printString ] ].
	}! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/22/2013 13:29:12.98'!
charAt: index
	^ self byteAt: index! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/22/2013 14:12:08.302'!
floatAt: index
	^ Float fromIEEE32Bit: (self uintAt: index)! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/22/2013 13:27:09.002'!
intAt: index
	^ ((self uintAt: index) bitInvert32 + 1) negated! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/22/2013 13:27:59.578'!
intAt: index put: anInteger
	^ self error: 'not yet implemented'! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/22/2013 13:33:34.4'!
longAt: index
	^ (((self ulongAt: index) bitXor: 16rFFFFFFFFFFFFFFFF) + 1) negated! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/22/2013 13:29:35.08'!
ucharAt: index
	^ ((self byteAt: index) bitInvert + 1) negated! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/22/2013 12:10:40.646'!
uintAt: index
	| n |
	n := 0.
	3 to: 0 by: -1 do: [ :i |
		n := (n bitShift: 8) + (self byteAt: index + i)
	].
	^ n! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/22/2013 11:09:00.532'!
uintAt: index put: anInteger
	0 to: 3 do: [ :i |
		self byteAt: index + i put: (anInteger digitAt: 4 - i).
	]! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/22/2013 13:23:39.95'!
ulongAt: index
	| n |
	n := 0.
	7 to: 0 by: -1 do: [ :i |
		n := (n bitShift: 8) + (self byteAt: index + i)
	].
	^ n! !

TestCase subclass: #MMByteArrayExtensionTest
	instanceVariableNames: 'bytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Tests'!

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 14:18:01.674'!
expectedFailures
	^ #(testDouble)! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 11:38:34.118'!
setUp
	bytes := #[110 166 99 74 251 33 9 64 190 0 254 240 66 255 1 255 66 69 1 53 65 69 1 245 190 186 254 202 190 186 254 202 80 250 72 56 0 0 188 65 1 42 0 0 0 0 0 0]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:24:28.906'!
testBool
	self assert: [ (bytes byteAt: 40+1) = 1 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:31:42.152'!
testChar
	self assert: [ (bytes charAt: 32+1) = $P asInteger ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:24:43.294'!
testDouble
	self assert: [ ((bytes doubleAt: 0+1) - 3.14159258) abs < 0.00001 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 14:14:10.732'!
testFloat
	self assert: [ (bytes floatAt: 36+1) = 23.5 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:24:23.3'!
testInt
	self assert: [ (bytes intAt: 8+1) = -251789122 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:24:52.984'!
testLong
	self assert: [ (bytes longAt: 16+1) = -792275913076030142 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:32:12.53'!
testUChar
	self assert: [ (bytes ucharAt: 33+1) = 250 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 12:13:13.44'!
testUint
	self assert: [ (bytes uintAt: 12+1) = 4278320962 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 12:13:51.114'!
testUlong
	self assert: [ (bytes ulongAt: 24+1) = 14627333968358193854 ]! !

TestCase subclass: #MMMemoryCellTest
	instanceVariableNames: 'memory startAddress size cell address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Tests'!

!MMMemoryCellTest methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:41:45.706'!
setUp
	startAddress := 16r1000.
	address := startAddress + 4.
	memory := MMMemory withStartAddress: startAddress bytes: #(1 2 3 4 5 6 7 8 9 10 11 12).
	
	cell := MMMemoryCell at: address in: memory! !

!MMMemoryCellTest methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:42:31.55'!
testAccess
	self assert: [ (cell byteAt: 0) == 5 ].
	self assert: [ (cell byteAt: 1) == 6 ].
	self assert: [ (cell byteAt: 2) == 7 ].
	self assert: [ (cell byteAt: 3) == 8 ].! !

!MMMemoryCellTest methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:45:00.558'!
testInitialization
	self assert: [ cell address == address ].
	self assert: [ cell memory == memory ]! !

TestCase subclass: #MMMemoryTest
	instanceVariableNames: 'startAddress size memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Tests'!

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 14:01:05.856'!
setUp
	startAddress := 4096.
	size := 4.
	memory := MMMemory withStartAddress: startAddress cellCount: size! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 14:09:14.552'!
testByteData
	memory at: startAddress putByteArray: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16).
	
	1 to: size * 4 do: [ :index |
		self assert: [ (memory byteAt: (index - 1 + startAddress)) == index ]
	]! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 14:06:38.408'!
testCellAccess
	self shouldnt: [ memory cellAtAddress: startAddress + 4 ] raise: Exception.
	self assert: [ (memory cellAtAddress: startAddress + 4) address == (startAddress + 4) ].
	
	self shouldnt: [ memory cellAtAddress: startAddress + 12 ] raise: Exception.
	self assert: [ (memory cellAtAddress: startAddress + 12) address == (startAddress + 12) ].
	
	self should: [ memory cellAtAddress: startAddress - 4 ] raise: Exception.
	
	self should: [ memory cellAtAddress: startAddress + (size * 4) ] raise: Exception
! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 15:07:50.83'!
testCellIteration
	| cellIndex |
	cellIndex := 0.
	
	memory cellsDo: [ :cell |
		self assert: [ cell address == (4*cellIndex + startAddress) ].
		cellIndex := cellIndex + 1
	].
	
	self assert: [ cellIndex == size ]! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:27:44.958'!
testEquality
	| secondMemory bytes |
	
	bytes := #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16).
	memory at: startAddress putByteArray: bytes.
	secondMemory := MMMemory withStartAddress: startAddress bytes: bytes.
	
	self assert: [ memory = secondMemory ].! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 14:11:49.834'!
testInitialization
	self assert: [ memory startAddress == startAddress ].
	self assert: [ memory cellCount == size ].
	self assert: [ memory byteSize == (size * MMMemoryCell size)].
	self assert: [ memory endAddress == (startAddress + (4 * size)) ]! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 14:10:07.36'!
testIntegerData
	memory at: startAddress putInt: 1.
	memory at: startAddress+4 putInt: 2.
	memory at: startAddress+8 putInt: 3.
	memory at: startAddress+12 putInt: 4.
	
	1 to: size do: [ :index |
		self assert: [ (memory intAt: (index - 1 * 4 + startAddress)) == index ]
	]! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 11:15:02.816'!
testLongData
	self shouldnt: [ memory at: startAddress putByteArray: (1 to: 20) asArray ] raise: Exception.
	self assert: [ memory cellCount == size ]! !

TestCase subclass: #MMRightAngledArrowTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Tests'!

!MMRightAngledArrowTest methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 14:05:05.36'!
arrowFrom: aPoint to: anotherPoint shouldHavePoints: aCollection
	self assert: [ (MMRightAngledArrow from: aPoint to: anotherPoint spacing: 30) points asArray = aCollection asArray ]! !

!MMRightAngledArrowTest methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 14:06:40.626'!
testPoints
	self arrowFrom: 0@0 to: 0@10 shouldHavePoints: { 0@0. 0@10 }.
	self arrowFrom: 0@0 to: 0@50 shouldHavePoints: { 0@0. -30@0. -30@50. 0@50 }.
	self arrowFrom: 0@0 to: 50@0 shouldHavePoints: { 0@0. 0@30. 50@30. 50@0 }.
	self arrowFrom: 0@0 to: 100@50 shouldHavePoints: { 0@0. 50@0. 50@50. 100@50 }.! !

Object subclass: #MMMemory
	instanceVariableNames: 'startAddress memory cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Core'!

!MMMemory class methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:25:14.594'!
withStartAddress: startAddress bytes: aByteArray

	^ self 
		withStartAddress: startAddress 
		bytes: aByteArray 
		cellCount: (aByteArray size / 4) ceiling! !

!MMMemory class methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:25:30.614'!
withStartAddress: startAddress bytes: aByteArray cellCount: aNumber
	|instance|
	instance := self withStartAddress: startAddress cellCount: aNumber.
	instance at: startAddress putByteArray: aByteArray.
	^ instance! !

!MMMemory class methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:17:01.288'!
withStartAddress: startAddress cellCount: aNumber
	^ self new
		initializeWithStartAddress: startAddress cellCount: aNumber;
		yourself! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:32:29.536'!
= anotherMMMemory
	self class == anotherMMMemory class ifFalse: [ ^ false ].
	startAddress == anotherMMMemory startAddress ifFalse: [ ^ false ].
	
	^ memory = anotherMMMemory memory! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:31:02.124'!
at: address putByte: byte
	memory byteAt: (self indexForAddress: address) put: byte! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 11:27:13.602'!
at: address putByteArray: byteArray
	(byteArray size > (cells size * 4) ifTrue: [ byteArray first: cells size * 4 ] ifFalse: [ byteArray ])
		withIndexDo: [ :byte :index |
		self at: address+index-1 putByte: (byteArray at: index)
	]! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:32:11.56'!
at: address putInt: int
	memory intAt: (self indexForAddress: address) put: int! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:25:05.046'!
byteAt: adress
	 ^ memory at: (self indexForAddress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 13:04:27.336'!
byteSize
	^ memory size! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:14:26.12'!
cellAtAddress: address
	^ cells at: (self cellIndexForAddress: address)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:53:43.905'!
cellCount
	^ cells size! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:13:45.782'!
cellIndexForAddress: address
	^ ((address roundDownTo: 4) - startAddress)/4 + 1! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:24:07.742'!
cellsDo: aBlock
	^ cells do: aBlock! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:36:41.85'!
charAt: adress
	 ^ memory charAt: (self indexForAddress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:54:00.067'!
endAddress
	^ startAddress + (self cellCount * MMMemoryCell size)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 14:20:02.262'!
floatAt: adress
	 ^ memory floatAt: (self indexForAddress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:12:46.656'!
indexForAddress: address
	^ address - startAddress + 1! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:16:31.907'!
initializeWithStartAddress: adress cellCount: aNumber
	startAddress := adress.
	memory := ByteArray new: aNumber*4.
	cells := OrderedCollection new.
	1 to: aNumber do: [ :i |
		cells add: (MMMemoryCell at: (4*(i-1) + startAddress) in: self)
	]! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:32:31.124'!
intAt: address
	 ^ memory intAt: (self indexForAddress: address)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:36:56.576'!
longAt: adress
	 ^ memory longAt: (self indexForAddress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:32:06.59'!
memory
	^ memory! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:12:09.978'!
startAddress
	^ startAddress! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:36:45.804'!
ucharAt: adress
	 ^ memory ucharAt: (self indexForAddress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:37:11.5'!
uintAt: adress
	 ^ memory uintAt: (self indexForAddress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:37:00.826'!
ulongAt: adress
	 ^ memory ulongAt: (self indexForAddress: adress)! !

Object subclass: #MMMemoryCell
	instanceVariableNames: 'address memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Core'!

!MMMemoryCell class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:15:46.536'!
at: address in: memory
	 ^ self new
		initializeWithAddress: address andMemory: memory;
		yourself! !

!MMMemoryCell class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 12:41:51.122'!
size
	 ^ 4! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:15:11.996'!
address
	^ address! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:22:27.266'!
byteAt: index
	^ memory byteAt: address + index! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:15:28.346'!
initializeWithAddress: anAddress andMemory: aMemory
	address := anAddress.
	memory := aMemory! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:53:00.459'!
memory
	^ memory! !

Object subclass: #MMPointerArrow
	instanceVariableNames: 'arrow fromCell toCell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMPointerArrow class methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 14:03:35.058'!
from: aMemoryCell
	^ self
		from: aMemoryCell
		to: nil! !

!MMPointerArrow class methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 14:03:40.86'!
from: aMemoryCell to: anotherMemoryCell
	^ super new
		fromCell: aMemoryCell;
		toCell: anotherMemoryCell;
		yourself! !

!MMPointerArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 14:02:26.484'!
fromCell
	^ fromCell! !

!MMPointerArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 14:10:16.43'!
fromCell: aMemoryCell
	fromCell ifNotNil: [ fromCell removePointerArrow: self ].
	fromCell := aMemoryCell.
	
	fromCell ifNotNil: [
		fromCell addPointerArrow: self.
		arrow := MMRightAngledArrow from: fromCell rightCenter to: self currentWorld currentHand center.
		arrow openInWorld
	]! !

!MMPointerArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 14:03:27.332'!
handleListenEvent: evt
	toCell ifNil: [
		arrow ifNotNil: [
			arrow initializeFrom: fromCell rightCenter to: evt position
		]
	].
	
	(evt isMouseUp) ifTrue: [ | morphs |
		self currentWorld currentHand removeMouseListener: self.
		
		morphs := self currentWorld morphsAt: evt position.
		(morphs detect: [ :morph | morph isKindOf: MMCellGroupMorph ] ifNone: [ nil ]) ifNil: [
			self delete
		] ifNotNil: [ :cellGroupMorph |
			self toCell: cellGroupMorph.
			self changed
		]
	]! !

!MMPointerArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 13:48:45.9'!
initialize
	super initialize.
	
	self currentWorld currentHand addMouseListener: self! !

!MMPointerArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 13:53:11.372'!
remove
	arrow delete! !

!MMPointerArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 14:02:47.636'!
toCell
	^ toCell! !

!MMPointerArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 14:02:52.478'!
toCell: aMemoryCell
	toCell := aMemoryCell.
	
	toCell ifNotNil: [
		self currentWorld currentHand removeMouseListener: self.
		
		arrow ifNotNil: [
			arrow initializeFrom: fromCell rightCenter to: toCell rightCenter
		]
	]! !
